#!/bin/bash

OPTIONS="-g -Wall -Wextra -Wno-unused-parameter"

echo "gcc $OPTIONS piece.c -c"
gcc $OPTIONS piece.c -c

echo "gcc $OPTIONS jeu.c -c"
gcc $OPTIONS jeu.c -c

echo "gcc $OPTIONS main.c -c"
gcc $OPTIONS main.c -c

echo "gcc $OPTIONS api_echec.c -c"
gcc $OPTIONS api_echec.c -c

echo "gcc $OPTIONS constructeur_piece.c -c"
gcc $OPTIONS constructeur_piece.c -c

echo "gcc $OPTIONS echiquier.c -c"
gcc $OPTIONS echiquier.c -c

echo "gcc $OPTIONS echiquier_deplacement.c -c"
gcc $OPTIONS echiquier_deplacement.c -c

echo "gcc $OPTIONS entree_sortie.c -c"
gcc $OPTIONS entree_sortie.c -c

echo "gcc $OPTIONS historique_partie.c -c"
gcc $OPTIONS historique_partie.c -c

echo "gcc $OPTIONS parseur_mode_interactif.c -c"
gcc $OPTIONS parseur_mode_interactif.c -c

echo "gcc $OPTIONS type_deplacement.c -c"
gcc $OPTIONS type_deplacement.c -c

echo "gcc piece.o jeu.o main.o api_echec.o constructeur_piece.o echiquier.o echiquier_deplacement.o entree_sortie.o historique_partie.o parseur_mode_interactif.o type_deplacement.o -o jeu_echec"
gcc piece.o jeu.o main.o api_echec.o constructeur_piece.o echiquier.o echiquier_deplacement.o entree_sortie.o historique_partie.o parseur_mode_interactif.o type_deplacement.o -o jeu_echec

echo "mv jeu_echec ../bin/"
mv jeu_echec ../bin/
