

/**
 * **************************************************
 * **************************************************
 *   _____ _____  ______   _
 *  / ____|  __ \|  ____| | |
 * | |    | |__) | |__    | |    _   _  ___  _ __
 * | |    |  ___/|  __|   | |   | | | |/ _ \| '_ \
 * | |____| |    | |____  | |___| |_| | (_) | | | |
 *  \_____|_|    |______| |______\__, |\___/|_| |_|
 *                                __/ |
 *                               |___/
 * **************************************************
 * **************************************************
 *
 *
 * Implementation des fonction de jeu.
 *
 */

//#Nom1: ZZZ
//#Prenom1: ZZZZ
//#Nom2: ZZZ
//#Prenom2: ZZZZ
//#Groupe: Z


#include "jeu.h"

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>





int jeu_compter_nombre_piece(const jeu* jeu_de_piece)
{
    assert(jeu_de_piece!=NULL);

    //Initialiser compteur <- 0
    //Tant que compteur<MAX_PIECE et piece courante est valide
    //  Incremente compteur si piece courante est valide
    //Retourne compteur

    printf("Fonction %s non implementee\n",__FUNCTION__);
    return 16; //valeur de retour arbitraire a modifier
}

int jeu_existe_piece(const jeu* jeu_de_piece,int coordonnee_x,int coordonnee_y)
{
    printf("Fonction %s non implementee\n",__FUNCTION__);
    return 0; //valeur par defaut a modifier !!!
}


piece *jeu_recuperer_piece(jeu *jeu_de_piece,int coordonnee_x,int coordonnee_y)
{
    printf("Fonction %s non implementee\n",__FUNCTION__);
    exit(0);
}


const piece *jeu_recuperer_piece_information(const jeu *jeu_de_piece,int coordonnee_x,int coordonnee_y)
{
    printf("Fonction %s non implementee\n",__FUNCTION__);
    exit(0);
}

const piece *jeu_recuperer_roi_information(const jeu *jeu_de_piece)
{
    printf("Fonction %s non implementee\n",__FUNCTION__);
    exit(0);
}


int jeu_est_integre(const jeu* jeu_de_piece)
{
    assert(jeu_de_piece!=NULL);

    //Parcours toutes les pieces valides jusqu'à rencontrer piece invalide ou fin de tableau
    int piece_valide=1;
    int indice_piece=0;
    do
    {
        const piece *piece_courante=&jeu_de_piece->ensemble_de_piece[indice_piece];
        if(piece_est_valide(piece_courante))
            indice_piece++;
        else
            piece_valide=0;

    }while(piece_valide==1 && indice_piece<MAX_PIECE);

    //Pour tout le reste du tableau
    //  Si rencontre piece invalide
    //    Alors retourne 0
    //Retourne 1
    while(indice_piece<MAX_PIECE)
    {
        const piece *piece_courante=&jeu_de_piece->ensemble_de_piece[indice_piece];

        if(piece_est_valide(piece_courante))
            return 0;

        indice_piece++;
    }


    //Recherche d'un roi unique:
    //
    //Initialise roi_unique <- faux
    //Pour toute les pieces
    //  Si piece courante est un roi
    //     Si roi_unique==vrai, Alors Renvoie 0
    //     Si roi_unique==faux, Alors roi_unique<-vrai
    //Si roi_unique==faux, Alors Renvoie 0
    int roi_unique=0;
    for(indice_piece=0;indice_piece<MAX_PIECE;++indice_piece)
    {
        const piece* piece_courante=&jeu_de_piece->ensemble_de_piece[indice_piece];
        if(piece_courante->type==roi)
        {
            if(roi_unique==1)
                return 0;
            roi_unique=1;
        }
    }
    if(roi_unique==0)
        return 0;


    return 1;
}

void jeu_supprimer_piece(jeu *jeu_de_piece,int coordonnee_x,int coordonnee_y)
{
    // Reflechir a l'algorithme avant de coder la fonction
    printf("Fonction %s non implementee\n",__FUNCTION__);
    exit(0);
}




void jeu_afficher_debug(const jeu* jeu_de_piece)
{
    assert(jeu_de_piece!=NULL);

    int k=0;
    int N=jeu_compter_nombre_piece(jeu_de_piece);

    for(k=0;k<N;++k)
        piece_afficher_debug(&jeu_de_piece->ensemble_de_piece[k]);
}

