
/**
 * **************************************************
 * **************************************************
 *   _____ _____  ______   _
 *  / ____|  __ \|  ____| | |
 * | |    | |__) | |__    | |    _   _  ___  _ __
 * | |    |  ___/|  __|   | |   | | | |/ _ \| '_ \
 * | |____| |    | |____  | |___| |_| | (_) | | | |
 *  \_____|_|    |______| |______\__, |\___/|_| |_|
 *                                __/ |
 *                               |___/
 * **************************************************
 * **************************************************
 *
 *
 * Implementation de piece.
 *
 */

//#Nom1: ZZZ
//#Prenom1: ZZZZ
//#Nom2: ZZZ
//#Prenom2: ZZZZ
//#Groupe: Z


#include "piece.h"

#include <assert.h>
#include <stdlib.h>
#include <stdio.h>


int coordonnee_est_valide(int coordonnee_x,int coordonnee_y)
{
    //Si coordonnees sont dans l'intervalle [0,7]
    //  Alors renvoie 1
    //Sinon renvoie 0
    if(coordonnee_x>=0 && coordonnee_y>=0 && coordonnee_x<=7 && coordonnee_y<=7)
        return 1;
    return 0;
}




// Ecrire ici le corps de la fonction "piece_est_valide"


void piece_invalider(piece* piece_du_jeu)
{
    //Attention fonction incomplete !!
    printf("Fonction %s non implementee \n",__FUNCTION__);
}




const char* nommer_type_de_piece(type_de_piece type)
{
    switch(type)
    {
    case tour:
        return "tour";
    case cavalier:
        return "cavalier";
    case fou:
        return "fou";
    case dame:
        return "dame";
    case roi:
        return "roi";
    case pion_blanc:
        return "pion (blanc)";
    case pion_noir:
        return "pion (noir)";
    case invalide:
        return "invalide";
    default:
        return "erreur piece non valide";
    }

    //le programme ne devrait jamais passer sur cette ligne
    abort();
}


void piece_afficher_debug(const piece* piece_du_jeu)
{
    assert(piece_du_jeu!=NULL);

    printf("type: %d (%s), coord: (%d,%d)\n",piece_du_jeu->type,
           nommer_type_de_piece(piece_du_jeu->type),
           piece_du_jeu->coord_x,piece_du_jeu->coord_y);
}

