#ifndef INCLUDE_GUARD_STRUCTURES_ECHIQUIER_H
#define INCLUDE_GUARD_STRUCTURES_ECHIQUIER_H

struct piece
{
  int type;
  int px;
  int py;
};


#define MAX_PIECE 16
struct jeu
{
  struct piece donnee[MAX_PIECE];
};


int jeu_nombre_piece(const struct jeu *j);
void echiquier_lit(struct jeu *j1,struct jeu *j2,const char *fichier,int *joueur_a_jouer);
int piece_est_valide(const struct piece *p);
int jeu_cherche_piece(const struct jeu* jeu_joueur,unsigned int x,unsigned int y);

#endif
