


/**
 * **************************************************
 * **************************************************
 *   _____ _____  ______   _
 *  / ____|  __ \|  ____| | |
 * | |    | |__) | |__    | |    _   _  ___  _ __
 * | |    |  ___/|  __|   | |   | | | |/ _ \| '_ \
 * | |____| |    | |____  | |___| |_| | (_) | | | |
 *  \_____|_|    |______| |______\__, |\___/|_| |_|
 *                                __/ |
 *                               |___/
 * **************************************************
 * **************************************************
 *
 *
 * Implementation des fonction de constructeur_piece
 *
 */

//#Nom1: ZZZ
//#Prenom1: ZZZZ
//#Nom2: ZZZ
//#Prenom2: ZZZZ
//#Groupe: Z

#include "constructeur_piece.h"

#include <stdio.h>
#include <assert.h>


void constructeur_piece_tour      (piece *piece_de_jeu,int coordonnee_x,int coordonnee_y)
{
    assert(piece_de_jeu!=NULL);
    assert(coordonnee_est_valide(coordonnee_x,coordonnee_y));

    //Affecte le type et les coordonnees a la piece
    piece_de_jeu->type=tour;
    piece_de_jeu->coord_x=coordonnee_x;
    piece_de_jeu->coord_y=coordonnee_y;

    assert(piece_est_valide(piece_de_jeu)==1);
}

void constructeur_piece_cavalier  (piece *piece_de_jeu,int coordonnee_x,int coordonnee_y)
{
    assert(piece_de_jeu!=NULL);
    assert(coordonnee_est_valide(coordonnee_x,coordonnee_y));

    //Affecte le type et les coordonnees a la piece
    piece_de_jeu->type=cavalier;
    piece_de_jeu->coord_x=coordonnee_x;
    piece_de_jeu->coord_y=coordonnee_y;

    assert(piece_est_valide(piece_de_jeu)==1);
}

void constructeur_piece_fou       (piece *piece_de_jeu,int coordonnee_x,int coordonnee_y)
{
    assert(piece_de_jeu!=NULL);
    assert(coordonnee_est_valide(coordonnee_x,coordonnee_y));

    //Affecte le type et les coordonnees a la piece
    piece_de_jeu->type=fou;
    piece_de_jeu->coord_x=coordonnee_x;
    piece_de_jeu->coord_y=coordonnee_y;

    assert(piece_est_valide(piece_de_jeu)==1);
}

void constructeur_piece_roi       (piece *piece_de_jeu,int coordonnee_x,int coordonnee_y)
{
    assert(piece_de_jeu!=NULL);
    assert(coordonnee_est_valide(coordonnee_x,coordonnee_y));

    //Affecte le type et les coordonnees a la piece
    piece_de_jeu->type=roi;
    piece_de_jeu->coord_x=coordonnee_x;
    piece_de_jeu->coord_y=coordonnee_y;

    assert(piece_est_valide(piece_de_jeu)==1);
}

void constructeur_piece_dame     (piece *piece_de_jeu,int coordonnee_x,int coordonnee_y)
{
    assert(piece_de_jeu!=NULL);
    assert(coordonnee_est_valide(coordonnee_x,coordonnee_y));

    //Affecte le type et les coordonnees a la piece
    piece_de_jeu->type=dame;
    piece_de_jeu->coord_x=coordonnee_x;
    piece_de_jeu->coord_y=coordonnee_y;

    assert(piece_est_valide(piece_de_jeu)==1);
}

void constructeur_piece_pion_blanc(piece *piece_de_jeu,int coordonnee_x,int coordonnee_y)
{
    assert(piece_de_jeu!=NULL);
    assert(coordonnee_est_valide(coordonnee_x,coordonnee_y));

    //Affecte le type et les coordonnees a la piece
    piece_de_jeu->type=pion_blanc;
    piece_de_jeu->coord_x=coordonnee_x;
    piece_de_jeu->coord_y=coordonnee_y;

    assert(piece_est_valide(piece_de_jeu)==1);
}

void constructeur_piece_pion_noir (piece *piece_de_jeu,int coordonnee_x,int coordonnee_y)
{
    assert(piece_de_jeu!=NULL);
    assert(coordonnee_est_valide(coordonnee_x,coordonnee_y));

    //Affecte le type et les coordonnees a la piece
    piece_de_jeu->type=pion_noir;
    piece_de_jeu->coord_x=coordonnee_x;
    piece_de_jeu->coord_y=coordonnee_y;

    assert(piece_est_valide(piece_de_jeu)==1);
}

